# --------------------------------------------------------------------
# argument -----------------------------------------------------------
#            Check command line arguments
# --------------------------------------------------------------------
# [arguments]
# argc  : Number of arguments.
# argv  : Arguments array
# --------------------------------------------------------------------
proc argument {argc argv} {
   # Global variables --------------------------------------------------
   global wk
   
   # Main --------------------------------------------------
   if { $argc == 0 } {
      # No aruguments
      return
   }
   # 
   while {[llength $argv] > 0} {
      set o [shift argv]
      switch -- $o {
	 -h          {puts_help}
	 --help       {puts_help}
	 -v          {puts_version}
	 --version    {puts_version}
	 default     {set fn $o}
      }
   }
   
   if { [file readable $fn] == 1} {
      # If readable, let us read it.
      bar_message "Load Project file \"$fn\" ..."
      update
      set wk(file,project) $fn
      read_project
   } else {
      puts stdout "Cannot read project file \"$fn\" ."
      puts_help
   }
}
# --------------------------------------------------------------------
# shift --------------------------------------------------------------
#            Emulate "shift" command of perl.
# --------------------------------------------------------------------
# [arguments]
# arrayname  : List
# --------------------------------------------------------------------
proc shift {arrayname} {
    upvar $arrayname array

    # Main --------------------------------------------------
    set first [lindex $array 0]
    set array [lrange $array 1 end]

    return $first
}
# --------------------------------------------------------------------
# puts_version -------------------------------------------------------
#            Display application version to STDOUT
# --------------------------------------------------------------------
proc puts_version {} {
    # global variables --------------------------------------------------
    global sys

    # Main --------------------------------------------------
    puts stdout [format "\nModeling. Ver. %s\n" $sys(VERSION)]
    puts stdout [format "\t by FUJIE Gou.\n" ]
    exit
}
# --------------------------------------------------------------------
# puts_help ----------------------------------------------------------
#            Display command line help to STDOUT
# --------------------------------------------------------------------
proc puts_help {} {
    puts stdout "\n% modeling \[options\] \[project_file\]"
    puts stdout " options ----"
    puts stdout "     -h    : show this help."
    puts stdout "     -v    : show program version."
    puts stdout " project_file ----"
    puts stdout "     specify a project file name(optionally)."
    puts stdout ""
    exit
}
