proc make_main_windows {} {
   global gbl wk sys zoomMod
   
   # Invoke main window --------------------------------------------------
   update_titlebar
   wm resizable . 1 1
   wm minsize . 650 500
   
   # --------------------------------------------------------------------
   # Menu bar -----------------------------------------------------------
   # --------------------------------------------------------------------

   set mf [menu .menuframe -tearoff 0]

   # File button --------------------------------------------------
   set m [menu $mf.file -tearoff 0]
   $mf add cascade -label "File" -menu $m -underline 0

   # Open Project menu
   $m add command -label "Open Project..." -accelerator Ctl-o\
       -command "open_project"
   # Save Project menu
   $m add command -label "Save Project..." -accelerator Ctl-s\
       -command "save_project overwrite"
   # Save Project As menu
   $m add command -label "Save Project As..." -command "save_project new"

   # Menu separator
   $m add separator

   # Model menu(Cascade) ----------
   set m2 $m.model
   $m add cascade -label "Model..." -menu $m2 -underline 0
   menu $m2 -tearoff 0
   $m2 add command -label "Create new..." -command "new_model"
   $m2 add command -label "Read from Ray86..."\
       -accelerator $gbl(option,option_key)-o -command "open_model ray86"
   $m2 add command -label "Read from v.in..." -command "open_model v.in"
   $m2 add command -label "Save as Ray86..."\
       -accel $gbl(option,option_key)-a -command "save_model ray86"
   $m2 add command -label "Save as v.in..." -command "save_model v.in"
   $m2 add command -label "Create from netCDF..." -command "model_from_netcdf"

   # Menu separator
   $m add separator

   # Model backup(Cascade) ----------
   set m2 $m.backup
   $m add cascade -label "Backup..." -menu $m2 -underline 0
   menu $m2 -tearoff 0
   # Make backup
   $m2 add command -label "Make backup..." -command "backup_make"\
       -accelerator $gbl(option,option_key)-b
   # Recover from backup
   set m3 $m2.recover
   set wk(backup,menuwidget) $m3
   $m2 add cascade -label "Recover..." -menu $m3 -underline 0
   menu $m3 -tearoff 0

   # Open Model menu
   $m2 add command -label "Cleanup old backup files..."\
       -command "backup_cleanup"

   # Menu separator
   $m add separator

   # Source menu(Cascade) ----------
   set m2 $m.source
   $m add cascade -label "Source parameters..." -menu $m2 -underline 0
   menu $m2 -tearoff 0
   # Read from text file
   $m2 add command -label "Read source parameters from text file"\
       -command "read_source_param"

   # Write to text file
   $m2 add command -label "Write source parameters to text file"\
       -command "write_source_param"

   # Menu separator
   $m add separator

   # PostScript menu
   $m add command -label "Save PostScript model..." -command "save_postscript"
   $m add command -label "Save PostScript T-X..." -command "TX::save_postscript"

   # Menu separator
   $m add separator
   # Quit menu
   $m add command -label "Quit..." -command "quit_application"\
       -accelerator Ctl+q

   # Edit menu button --------------------------------------------------
   set m [menu $mf.edit -tearoff 0]
   $mf add cascade -label "Edit" -menu $m -underline 0

   # Undo 
   $m add command -label "Undo   " -command "undo"\
       -accelerator Meta+u
   # Menu separator
   $m add separator

   # Interface menu(Cascade) -----
   set m2 $m.interface
   $m add cascade -label "Interface" -menu $m2 -underline 0
   menu $m2 -tearoff 0
   $m2 add command -label "Parallel shift" -command "move_interface"
   $m2 add separator
   $m2 add command -label "Pinch Out" -command "pinchout_interface"
   $m2 add command -label "Delete" -command "delete_interface"
   $m2 add separator
   $m2 add command -label "New interface upside" -command "insert_interface up"
   $m2 add command -label "New interface downside" -command "insert_interface down"
   $m2 add command -label "New interface from (x,z) data file" \
       -command "read_interface" 
   $m2 add command -label "Replace a layer with (x,vtop,vbot) data file" \
       -command "read_layer" 

   # V-grid menu (Cascade) -----
   set m2 $m.vgrid
   $m add cascade -label "V-grid" -menu $m2 -underline 0
   menu $m2 -tearoff 0
   $m2 add command -label "V-grid at regular spacings" \
       -command "vgrid_regular_spacing" 
   $m2 add command -label "Edit multiple velocity grids" \
       -command "edit_multiple_vgrids"

   # Option menu --------------------------------------------------
   set m [menu $mf.option -tearoff 0]
   $mf add cascade -label "Option" -menu $m -underline 3

   # backend program
   set m2 [menu $m.backend -tearoff 0]
   $m add cascade -label "Backend raytracing program" -menu $m2
   set wk(w,backend_menu) $m2

   # Toggle of velocity grid display
   $m add checkbutton -label "show velocity grid"\
       -variable gbl(option,grid) -command draw_grid
   # Toggle of velocity label display
   $m add checkbutton -label "show velocity label"\
       -variable gbl(option,label) -command draw_grid
   # Toggle of source mark display
   $m add checkbutton -label "show source location"\
       -variable gbl(option,source) -command draw_source
   # Toggle of velocity image
   $m add checkbutton -label "show background image"\
       -variable gbl(hamen,velimage) -command toggle_bgimage
   # Toggle of exec conditions display
   $m add checkbutton -label "show stdout of external program"\
       -variable gbl(option,exec_condition)
   # Toggle of Relative path
   $m add checkbutton -label "save filenames with relative paths"\
       -variable gbl(option,use_relative_path)

   # Velocity value and Poisson's ratio at the cursor point(Cascade) -----
   set m2 $m.vel
   $m add cascade -label "show velocity and Poisson's ratio"\
       -menu $m2 -underline 0
   menu $m2 -tearoff 0
   foreach {i j} {"No" 0  "P velocity and P gradient" 1\
		      "P velocity and Poisson's ratio" 2\
		      "P velocity and S velocity" 3\
		      "S and Poisson's ratio" 4\
		      "P and S velocity and Poisson's ratio" 5} {
      $m2 add radiobutton -label $i -variable gbl(option,vel)\
	  -value $j
   }

   # Change velocity font(Cascade) -----
   set m2 $m.font
   $m add cascade -label "Velocity Font" -menu $m2 -underline 0
   menu $m2 -tearoff 0
   foreach {i j} $sys(VELOCITY_FONTS) {
      $m2 add radiobutton -label $i -variable gbl(option,label_font)\
	  -value $i -command "update_velocity_font"
   }

   # Hide axis(Cascade) -----
   set m2 $m.hide_axis
   $m add cascade -label "Hide axis" -menu $m2 -underline 0
   menu $m2 -tearoff 0
   foreach {i j} {top x2 right y2} {
      $m2 add checkbutton -label "Hide $i axis" -variable gbl(option,$j\_axis)\
	  -command "update_hide_axis $j"
   }

   # Raytracing window size(Cascade) -----
   set m2 $m.size
   $m add cascade -label "Raytrace Window Size" -menu $m2 -underline 0
   menu $m2 -tearoff 0
   $m2 add command -label "Small" -command "change_size small"
   $m2 add command -label "Medium" -command "change_size medium"
   $m2 add command -label "Large" -command "change_size large"
   $m2 add command -label "A4 paper" -command "change_size A4"

   # option key (Cascade) -----
   set m2 $m.optionkey
   $m add cascade -label "Option Key" -menu $m2 -underline 0
   menu $m2 -tearoff 0
   $m2 add radiobutton -label "Alt" -variable gbl(option,option_key)\
       -command update_bindings
   $m2 add radiobutton -label "Meta" -variable gbl(option,option_key)\
       -command update_bindings
   $m2 add radiobutton -label "CapsLock" -value "Lock"\
       -variable gbl(option,option_key) -command update_bindings

   # Menu separator
   $m add separator

   # Parameter file generation for Inversion program (do_inver)
   $m add checkbutton -label "Standard-Deviation" -variable gbl(ERI,inv)

   # Vp/Vs structure
   set m2 $m.poisson
   $m add cascade -label "Vp/Vs" -menu $m2 -underline 0
   menu $m2 -tearoff 0
   foreach {i j} {"None" 0\
		      "1 value per 1 layer" 1\
		      "1 value per 1 grid" 2\
		      "top and bottom values per 1 grid" 3} {
      $m2 add radiobutton -label $i -command change_poisson_settings\
	  -variable gbl(ERI,poisson) -val $j
   }

   # Output velocity structure data for GMT scripts.
   $m add separator
   $m add command -label "Export data..." -command "export_data"

   # Parameter menu ----------
   set m [menu $mf.parameter -tearoff 0]
   $mf add cascade -label "Parameter" -menu $m -underline 0

   $m add command -label "Set SOURCE parameter ..." -command "source_parameter"\
       -accelerator "  s"
   $m add command -label "Set RAYGroup parameter ..." -command "ray_parameter"\
       -accelerator "  r"
   set wk(w,parameter_menu) $m

   # RunProgram menu ----------
   set m [menu $mf.run -tearoff 0]
   $mf add cascade -label "RunProgram" -menu $m -underline 0

   $m add command -label "Raytracing..." -accelerator Ctl-x\
       -command "raytrace"
   $m add command -label "Amplitude computation..." -accelerator Ctl-a\
       -command "calc_amplitude"
   $m add command -label "Synthetic Section..."\
       -command "display_synthetic_section text"
   $m add command -label "Run X-Section..." -accelerator Ctl-e\
       -command "display_synthetic_section x"
   $m add separator
   $m add command -label "Clear rays in edit window" -command "RAYPATH::clear"\
       -accelerator Ctl-c
   $m add command -label "Update velocity image" -command "update_velimage"\
       -accelerator Ctl-v

   # Help menu ----------
   set m [menu $mf.help -tearoff 0]
   $mf add cascade -label "Help" -menu $m -underline 0

   # Mouse bindings.
   $m add command -label "Mouse bindings." -command "help_mousebind"

   # File format help
   $m add command -label "File Formats." -command "help_file_format"

   # Show version.
   $m add command -label "Version Info." -command "show_version"

   # Show history.txt
   $m add command -label "History." -command "help_history"

   # Show bug report help
   $m add command -label "Bug report" -command "bug_report"

   # menu bar ----------
   . conf -menu $mf

   # --------------------------------------------------------------------
   # Paned window
   # --------------------------------------------------------------------

   set pw [panedwindow .pane -orient vertical]

   # Model region --------------------------------------------------
   set sys(graph) $pw.graph
   graph $sys(graph) -plotpadx 16 -plotpady 16 -width 650\
       -leftmargin 70 -rightmargin 48 -height 4i
   # graph appearance ----------
   $sys(graph) legend conf -hide 1
   $sys(graph) pen create interfacePen
   $sys(graph) pen configure interfacePen -pixel 7 -linewidth 0 -color yellow4
   $sys(graph) pen configure "activeLine" -pixel 0 -linewidth 2 -color red
   # axis
   $sys(graph) yaxis configure -descending 1
   $sys(graph) y2axis configure -descending 1
   $sys(graph) x2axis configure -hide $gbl(option,x2_axis)
   $sys(graph) y2axis configure -hide $gbl(option,y2_axis)
   # zoom
   Blt_Crosshairs $sys(graph)
   set zoomMod "Control-"
   Blt_ZoomStack $sys(graph)
   # cross hair cursor
   $sys(graph) crosshairs configure -color green
   # bindings
   update_bindings

   # TX region --------------------------------------------------
   set sys(tx) $pw.txgraph
   # graph appearance ----------
   graph $sys(tx) -plotpadx 16 -plotpady 16 -leftmargin 70 -rightmargin 48 -height 2i
   $sys(tx) pen configure "activeLine" -color red
   # labels
   $sys(tx) configure -title "T-X graph"
   $sys(tx) legend conf -hide 1
   # axis
   $sys(tx) yaxis configure -title "T(sec)"
   $sys(tx) y2axis configure -hide $gbl(option,y2_axis)
   # grid display
   $sys(tx) grid on
   # graph functions ----------
   # zoom
   Blt_Crosshairs $sys(tx)
   Blt_ZoomStack $sys(tx)
   # cross hair cursor
   $sys(tx) crosshairs configure -color green

   $pw add $sys(graph) $sys(tx)

   # --------------------------------------------------------------------
   # Bottom bars
   # --------------------------------------------------------------------

   # Position bar --------------------------------------------------
   set pos $wk(w,pos)
   frame $pos -relief flat
   message $pos.message -text "(x, y)" -anchor w -aspect 10000 -width 0
   pack $pos.message -in $pos -anchor w -expand 1

   # Message bar --------------------------------------------------
   set bar $wk(w,bar)
   frame $bar -relief ridge -bd 2
   message $bar.message -text "Welcome to the Modeling application !!"\
       -anchor w -aspect 10000 -width 0
   gf_optionMenu $bar.binding wk(current_bindings) \
       update_bindings Node Node V-Grid V-Grid
   pack $bar.message -in $bar -anchor w -expand 1 -side left
   pack $bar.binding -side right
   $bar.binding.menu invoke 0
   bind $bar.binding <Button-4> "change_bindings -1"
   bind $bar.binding <Button-5> "change_bindings +1"

   # Key bindings --------------------------------------------------
   bind . <Control-q> "quit_application"
   bind . <Control-x> "raytrace"
   bind . <Control-a> "calc_amplitude"
   bind . <Control-e> "display_synthetic_section x"
   bind . <Control-o> "open_project"
   bind . <Control-s> "save_project overwrite"
   bind . <Control-c> "RAYPATH::clear"
   bind . <Control-z> "undo"
   bind . <Control-b> "change_bindings +1"
   bind $sys(graph) <Control-Button-2> "undo"
   bind $sys(graph) <Any-Motion> "show_position %x %y"

   # Key bindings in the T-X window
   bind $sys(tx) <Any-Motion> "TX::show_position %x %y"
   bind $sys(tx) <Button-2> "TX::highlight %x %y"
   bind $sys(tx) <Double-Button-1> "TX::select_axis %x %y %X %Y"

   # Key bindings to invoke sub-windows
   bind . s "source_parameter"
   bind . r "ray_parameter"
   bind . <Control-t> "toggle_bgimage"
   bind . <Control-v> "update_bgimage"

   # Pack all the widgets in main ----------------------------------------
   pack $pw $pos $bar -side top -fill x
   pack $pw -fill both -expand 1 -side top
   pack $pos $bar -side top -fill x
}
