namespace eval RAYPATH {
   namespace export *

   # --------------------------------------------------------------------
   # plot single raypath
   #   type  : ray type (integer) ; used for determining ray color
   #   src   : shot (or OBS) number (integer) ; used for determining ray color
   #   coord : coordinates, x1,z1, x2,z2, .... ,xn,zn
   # --------------------------------------------------------------------
   proc plot1 {type src coord} {
      # Global variables --------------------------------------------------
      global sys wk
      
      # Main --------------------------------------------------
      $sys(graph) element create ray($wk(ray,n)) -data [join $coord]\
	  -pixels 0 -color [color $type $src]
      incr wk(ray,n)
   }

   # --------------------------------------------------------------------
   # clear all raypaths
   # --------------------------------------------------------------------
   proc clear {} {
      # Global variables
      global sys wk
      
      # Main
      set wk(ray,n) 0
      eval {$sys(graph) element delete} [$sys(graph) element names ray(*)]
   }

   # --------------------------------------------------------------------
   # lower raypaths
   # --------------------------------------------------------------------
   proc lower {} {
      # Global variables --------------------------------------------------
      global sys wk
      
      # Main --------------------------------------------------
      set except_rays [$sys(graph) element names interface(*) graph_frame]
      set rays [$sys(graph) element names ray(*)]
      $sys(graph) element show [concat $rays $except_rays]
   }

   # --------------------------------------------------------------------
   # define colors for raypaths
   # --------------------------------------------------------------------
   proc define_color {} {
      # Global variables
      global sys wk gbl
      
      # Main
      switch -- $gbl(plot,ray_color) {
	 3 {
	    # color by ray group
	    set wk(ray,ray_list) [make_ray_list]
	    set wk(ray,color_list) $sys(colors)
	    set wk(ray,n_color) [llength $sys(colors)]
	    proc color {ray src} {
	       global wk
	       return [lindex $wk(ray,color_list) \
			   [expr [lsearch $wk(ray,ray_list) $ray]\
				% $wk(ray,n_color) ] ]
	    }
	 }
	 2 {
	    # color by shot (OBS)
	    set wk(ray,color_list) $sys(colors)
	    set wk(ray,n_color) [llength $sys(colors)]
	    proc color {ray src} {
	       global wk
	       return [lindex $wk(ray,color_list) \
			   [expr ($src-1) % $wk(ray,n_color)]]
	    }
	 }
	 default {
	    # black
	    proc color {ray src} {
	       return "black"
	    }
	 }

      }
   }
}