# --------------------------------------------------------------------
# display_synthetic_section ------------------------------------------
#            Display Synthetic Section 
# --------------------------------------------------------------------
# [argument]
# mode : 'x' or 'text'
# --------------------------------------------------------------------
proc display_synthetic_section {mode} {
   # Global variables --------------------------------------------------
   global gbl sys
   
   # Main --------------------------------------------------
   # Generate "s.in" ----------
   bar_message "Making Parameter file 's.in' for Synthetic Section ...."
   update
   if {[RAYINVR::make_sin] != 0} {
      bar_message "ERROR: Can't make 's.in' file"
      return
   }
   # Generate "w.in", if necessary.
   if { $gbl(zelt,section,iwavlt) == 2 } {
      file copy -force $gbl(file,wavelet) "./w.in"
   }

   # Execute Synthetic Section program ----------
   bar_message "Now making Synthetic Section..."
   update
   switch $mode {
      "text" {
	 set com [open "| $sys(rayinvr,SYNTHETIC)" r+]
	 RAYINVR::exec_rayinvr 0 $com
      }
      "x" {
	 set com [open "| $sys(rayinvr,XSYNTHETIC)" r+]
	 RAYINVR::exec_rayinvr 1 $com
      }
   }

   # message ----------
   bar_message "END: Synthetic Section."
}